Index: /pykota/trunk/pykota/storages/ldapstorage.py
===================================================================
--- /pykota/trunk/pykota/storages/ldapstorage.py (revision 2950)
+++ /pykota/trunk/pykota/storages/ldapstorage.py (revision 2953)
@@ -621,5 +621,5 @@
                 date = fields.get("createTimestamp", ["19700101000000Z"])[0] # It's in UTC !
                 mxtime = DateTime.strptime(date[:14], "%Y%m%d%H%M%S").localtime()
-                lastjob.JobDate = mxtime.strftime("%Y%m%d %H:%M:%S")
+                lastjob.JobDate = mxtime.strftime("%Y-%m-%d %H:%M:%S")
                 lastjob.Exists = True
         return lastjob
@@ -1376,5 +1376,5 @@
                 date = fields.get("createTimestamp", ["19700101000000Z"])[0] # It's in UTC !
                 mxtime = DateTime.strptime(date[:14], "%Y%m%d%H%M%S").localtime()
-                job.JobDate = mxtime.strftime("%Y%m%d %H:%M:%S")
+                job.JobDate = mxtime.strftime("%Y-%m-%d %H:%M:%S")
                 if ((start is None) and (end is None)) or \
                    ((start is None) and (job.JobDate <= end)) or \
Index: /pykota/trunk/pykota/storage.py
===================================================================
--- /pykota/trunk/pykota/storage.py (revision 2945)
+++ /pykota/trunk/pykota/storage.py (revision 2953)
@@ -745,4 +745,16 @@
         if start and end and (start > end) :
             (start, end) = (end, start)
+        try :    
+            if len(start) == 17 :
+                start = "%s-%s-%s %s" % (start[0:4], start[4:6], start[6:8], start[9:])
+        except TypeError :        
+            pass
+            
+        try :    
+            if len(end) == 17 :
+                end = "%s-%s-%s %s" % (end[0:4], end[4:6], end[6:8], end[9:])
+        except TypeError :        
+            pass
+            
         return (start, end)    
         
Index: /pykota/trunk/cgi-bin/printquota.cgi
===================================================================
--- /pykota/trunk/cgi-bin/printquota.cgi (revision 2909)
+++ /pykota/trunk/cgi-bin/printquota.cgi (revision 2953)
@@ -241,8 +241,9 @@
                         else :    
                             billingcode_url = None
+                        curdate = DateTime.ISO.ParseDateTime(str(job.JobDate))
                         self.report.append('<tr class="%s">%s</tr>' % \
                                               (oddevenclass, \
                                                "".join(["<td>%s</td>" % (h or "&nbsp;") \
-                                                  for h in (str(job.JobDate[:19]), \
+                                                  for h in (str(curdate)[:19], \
                                                             _(job.JobAction), \
                                                             username_url, \
@@ -264,7 +265,12 @@
                                                             job.JobPages)])))
                     self.report.append('</table>')
-                    d = DateTime.ISO.ParseDateTime(str(job.JobDate))
                     dico = { "history" : 1,
-                             "datelimit" : "%04i%02i%02i %02i:%02i:%02i" % (d.year, d.month, d.day, d.hour, d.minute, d.second),
+                             "datelimit" : "%04i-%02i-%02i %02i:%02i:%02i" \
+                                                         % (curdate.year, \
+                                                            curdate.month, \
+                                                            curdate.day, \
+                                                            curdate.hour, \
+                                                            curdate.minute, \
+                                                            curdate.second),
                            }
                     if user and user.Exists :
Index: /pykota/trunk/NEWS
===================================================================
--- /pykota/trunk/NEWS (revision 2937)
+++ /pykota/trunk/NEWS (revision 2953)
@@ -22,4 +22,11 @@
 PyKota NEWS :
        
+    - 1.25alpha7 (2006-06-20) :
+    
+        - Fixed some date formatting problems when retrieving the 
+          printing history with MySQL.
+          
+        - Began code cleaning.  
+          
     - 1.25alpha6 (2006-06-13) :
     