Index: pykota/trunk/pykota/accounters/snmp.py
===================================================================
--- pykota/trunk/pykota/accounters/snmp.py (revision 3028)
+++ pykota/trunk/pykota/accounters/snmp.py (revision 3039)
@@ -102,4 +102,5 @@
                     'Input Tray Empty',
                   ]
+# WARNING : some printers don't support this one :                  
 prtConsoleDisplayBufferTextOID = "1.3.6.1.2.1.43.16.5.1.2.1.1" # SNMPv2-SMI::mib-2.43.16.5.1.2.1.1
 
@@ -122,5 +123,4 @@
         self.deviceStatus = None
         self.printerDetectedErrorState = None
-        self.consoleDisplayBufferText = None
         self.timebefore = time.time()   # resets timer also in case of error
         
@@ -251,6 +251,5 @@
                                                   tuple([int(i) for i in hrPrinterStatusOID.split('.')]), \
                                                   tuple([int(i) for i in hrDeviceStatusOID.split('.')]), \
-                                                  tuple([int(i) for i in hrPrinterDetectedErrorStateOID.split('.')]), \
-                                                  tuple([int(i) for i in prtConsoleDisplayBufferTextOID.split('.')]))
+                                                  tuple([int(i) for i in hrPrinterDetectedErrorStateOID.split('.')]))
             if errorIndication :                                                  
                 self.parent.filter.printInfo("SNMP Error : %s" % errorIndication, "error")
@@ -266,11 +265,9 @@
                 self.deviceStatus = int(varBinds[2][1].prettyPrint())
                 self.printerDetectedErrorState = self.extractErrorStates(str(varBinds[3][1]))
-                self.consoleDisplayBufferText = varBinds[4][1].prettyPrint()
-                self.parent.filter.logdebug("SNMP answer decoded : PageCounter : %s  PrinterStatus : '%s'  DeviceStatus : '%s'  PrinterErrorState : '%s'  ConsoleDisplayBuffer : '%s'" \
+                self.parent.filter.logdebug("SNMP answer decoded : PageCounter : %s  PrinterStatus : '%s'  DeviceStatus : '%s'  PrinterErrorState : '%s'" \
                      % (self.printerInternalPageCounter, \
                         printerStatusValues.get(self.printerStatus), \
                         deviceStatusValues.get(self.deviceStatus), \
-                        self.printerDetectedErrorState, \
-                        self.consoleDisplayBufferText))
+                        self.printerDetectedErrorState))
 else :
     class Handler(BaseHandler) :
@@ -285,6 +282,5 @@
                                                         (hrPrinterStatusOID, ver.Null()), \
                                                         (hrDeviceStatusOID, ver.Null()), \
-                                                        (hrPrinterDetectedErrorStateOID, ver.Null()), \
-                                                        (prtConsoleDisplayBufferTextOID, ver.Null()))
+                                                        (hrPrinterDetectedErrorStateOID, ver.Null()))
             tsp = Manager()
             try :
@@ -321,11 +317,9 @@
                             self.deviceStatus = self.values[2]
                             self.printerDetectedErrorState = self.extractErrorStates(self.values[3])
-                            self.consoleDisplayBufferText = self.values[4]
-                            self.parent.filter.logdebug("SNMP answer decoded : PageCounter : %s  PrinterStatus : '%s'  DeviceStatus : '%s'  PrinterErrorState : '%s'  ConsoleDisplayBuffer : '%s'" \
+                            self.parent.filter.logdebug("SNMP answer decoded : PageCounter : %s  PrinterStatus : '%s'  DeviceStatus : '%s'  PrinterErrorState : '%s'" \
                                  % (self.printerInternalPageCounter, \
                                     printerStatusValues.get(self.printerStatus), \
                                     deviceStatusValues.get(self.deviceStatus), \
-                                    self.printerDetectedErrorState, \
-                                    self.consoleDisplayBufferText))
+                                    self.printerDetectedErrorState))
                         except IndexError :    
                             self.parent.filter.logdebug("SNMP answer is incomplete : %s" % str(self.values))