Index: /pykota/trunk/pykota/dumper.py
===================================================================
--- /pykota/trunk/pykota/dumper.py (revision 3030)
+++ /pykota/trunk/pykota/dumper.py (revision 3050)
@@ -255,5 +255,5 @@
             username = entry[fields["username"]]
             jobid = entry[fields["jobid"]]
-            jobdate = DateTime.ISO.ParseDateTime(str(entry[fields["jobdate"]]))
+            jobdate = DateTime.ISO.ParseDateTime(str(entry[fields["jobdate"]])[:19])
             gmtoffset = jobdate.gmtoffset()
             jobdate = "%s %+03i00" % (jobdate.strftime("%d/%b/%Y:%H:%M:%S"), gmtoffset.hour)
Index: /pykota/trunk/pykota/tool.py
===================================================================
--- /pykota/trunk/pykota/tool.py (revision 3045)
+++ /pykota/trunk/pykota/tool.py (revision 3050)
@@ -544,5 +544,5 @@
                             now = DateTime.now()
                             if userpquota.DateLimit is not None :
-                                datelimit = DateTime.ISO.ParseDateTime(str(userpquota.DateLimit))
+                                datelimit = DateTime.ISO.ParseDateTime(str(userpquota.DateLimit)[:19])
                             else :
                                 datelimit = now + self.config.getGraceDelay(printer.Name)
@@ -603,5 +603,5 @@
                             now = DateTime.now()
                             if grouppquota.DateLimit is not None :
-                                datelimit = DateTime.ISO.ParseDateTime(str(grouppquota.DateLimit))
+                                datelimit = DateTime.ISO.ParseDateTime(str(grouppquota.DateLimit)[:19])
                             else :
                                 datelimit = now + self.config.getGraceDelay(printer.Name)
Index: /pykota/trunk/pykota/reporter.py
===================================================================
--- /pykota/trunk/pykota/reporter.py (revision 2945)
+++ /pykota/trunk/pykota/reporter.py (revision 3050)
@@ -94,5 +94,5 @@
             elif quota.DateLimit is not None :
                 now = DateTime.now()
-                datelimit = DateTime.ISO.ParseDateTime(str(quota.DateLimit))
+                datelimit = DateTime.ISO.ParseDateTime(str(quota.DateLimit)[:19])
                 if now >= datelimit :
                     datelimit = "DENY"
Index: /pykota/trunk/pykota/storage.py
===================================================================
--- /pykota/trunk/pykota/storage.py (revision 3036)
+++ /pykota/trunk/pykota/storage.py (revision 3050)
@@ -261,5 +261,5 @@
     def setDateLimit(self, datelimit) :    
         """Sets the date limit for this quota."""
-        datelimit = DateTime.ISO.ParseDateTime(str(datelimit))
+        datelimit = DateTime.ISO.ParseDateTime(str(datelimit)[:19])
         date = "%04i-%02i-%02i %02i:%02i:%02i" % (datelimit.year, datelimit.month, datelimit.day, datelimit.hour, datelimit.minute, datelimit.second)
         self.parent.writeUserPQuotaDateLimit(self, date)
@@ -403,5 +403,5 @@
     def setDateLimit(self, datelimit) :    
         """Sets the date limit for this quota."""
-        datelimit = DateTime.ISO.ParseDateTime(str(datelimit))
+        datelimit = DateTime.ISO.ParseDateTime(str(datelimit)[:19])
         date = "%04i-%02i-%02i %02i:%02i:%02i" % (datelimit.year, \
                                                   datelimit.month, \
@@ -759,5 +759,5 @@
                         dateval = None
                     try :    
-                        DateTime.ISO.ParseDateTime(dateval)
+                        DateTime.ISO.ParseDateTime(dateval[:19])
                     except :    
                         dateval = None
Index: /pykota/trunk/cgi-bin/printquota.cgi
===================================================================
--- /pykota/trunk/cgi-bin/printquota.cgi (revision 2953)
+++ /pykota/trunk/cgi-bin/printquota.cgi (revision 3050)
@@ -241,5 +241,5 @@
                         else :    
                             billingcode_url = None
-                        curdate = DateTime.ISO.ParseDateTime(str(job.JobDate))
+                        curdate = DateTime.ISO.ParseDateTime(str(job.JobDate)[:19])
                         self.report.append('<tr class="%s">%s</tr>' % \
                                               (oddevenclass, \
Index: /pykota/trunk/bin/cupspykota
===================================================================
--- /pykota/trunk/bin/cupspykota (revision 3049)
+++ /pykota/trunk/bin/cupspykota (revision 3050)
@@ -947,5 +947,5 @@
                 now = DateTime.now()
                 try :
-                    previous = DateTime.ISO.ParseDateTime(str(self.Printer.LastJob.JobDate)).localtime()
+                    previous = DateTime.ISO.ParseDateTime(str(self.Printer.LastJob.JobDate)[:19]).localtime()
                 except :
                     previous = now
Index: /pykota/trunk/NEWS
===================================================================
--- /pykota/trunk/NEWS (revision 3048)
+++ /pykota/trunk/NEWS (revision 3050)
@@ -24,4 +24,6 @@
     - 1.25alpha15 (2006-11-06) :   
     
+        - Fixed date and time parsing problems.
+        
         - Finally simplified the locking code again, and checked that no
           stalled lock can persist. The lock files remain on disk though,