Index: pykota/trunk/man/pt_BR/edpykota.1
===================================================================
--- pykota/trunk/man/pt_BR/edpykota.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/edpykota.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH EDPYKOTA "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH EDPYKOTA "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-edpykota \- page de manuel de edpykota 1.25alpha5_unofficial
+edpykota \- page de manuel de edpykota 1.25alpha16_unofficial
 .SH DESCRIPTION
-edpykota v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+edpykota v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 A Print Quota editor for PyKota.
Index: pykota/trunk/man/pt_BR/pkinvoice.1
===================================================================
--- pykota/trunk/man/pt_BR/pkinvoice.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/pkinvoice.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PKINVOICE "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PKINVOICE "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkinvoice \- page de manuel de pkinvoice 1.25alpha5_unofficial
+pkinvoice \- page de manuel de pkinvoice 1.25alpha16_unofficial
 .SH DESCRIPTION
-pkinvoice v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+pkinvoice v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 An invoice generator for PyKota.
Index: pykota/trunk/man/pt_BR/pykotme.1
===================================================================
--- pykota/trunk/man/pt_BR/pykotme.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/pykotme.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PYKOTME "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PYKOTME "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pykotme \- page de manuel de pykotme 1.25alpha5_unofficial
+pykotme \- page de manuel de pykotme 1.25alpha16_unofficial
 .SH DESCRIPTION
-pykotme v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+pykotme v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 Gives print quotes to users.
Index: pykota/trunk/man/pt_BR/pkbcodes.1
===================================================================
--- pykota/trunk/man/pt_BR/pkbcodes.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/pkbcodes.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PKBCODES "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PKBCODES "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkbcodes \- page de manuel de pkbcodes 1.25alpha5_unofficial
+pkbcodes \- page de manuel de pkbcodes 1.25alpha16_unofficial
 .SH DESCRIPTION
-pkbcodes v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+pkbcodes v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 A billing codes Manager for PyKota.
Index: pykota/trunk/man/pt_BR/pkusers.1
===================================================================
--- pykota/trunk/man/pt_BR/pkusers.1 (revision 2937)
+++ pykota/trunk/man/pt_BR/pkusers.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PKUSERS "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PKUSERS "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkusers \- page de manuel de pkusers 1.25alpha7_unofficial
+pkusers \- page de manuel de pkusers 1.25alpha16_unofficial
 .SH DESCRIPTION
-pkusers v1.25alpha7_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+pkusers v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 An Users and Groups Manager for PyKota.
Index: pykota/trunk/man/pt_BR/pkturnkey.1
===================================================================
--- pykota/trunk/man/pt_BR/pkturnkey.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/pkturnkey.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PKTURNKEY "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PKTURNKEY "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkturnkey \- page de manuel de pkturnkey 1.25alpha5_unofficial
+pkturnkey \- page de manuel de pkturnkey 1.25alpha16_unofficial
 .SH DESCRIPTION
-pkturnkey v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+pkturnkey v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 A turn key tool for PyKota. When launched, this command will initialize
Index: pykota/trunk/man/pt_BR/repykota.1
===================================================================
--- pykota/trunk/man/pt_BR/repykota.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/repykota.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH REPYKOTA "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH REPYKOTA "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-repykota \- page de manuel de repykota 1.25alpha5_unofficial
+repykota \- page de manuel de repykota 1.25alpha16_unofficial
 .SH DESCRIPTION
-repykota v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+repykota v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 Generates print quota reports.
Index: pykota/trunk/man/pt_BR/warnpykota.1
===================================================================
--- pykota/trunk/man/pt_BR/warnpykota.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/warnpykota.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH WARNPYKOTA "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH WARNPYKOTA "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-warnpykota \- page de manuel de warnpykota 1.25alpha5_unofficial
+warnpykota \- page de manuel de warnpykota 1.25alpha16_unofficial
 .SH DESCRIPTION
-warnpykota v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+warnpykota v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 Sends mail to users over print quota.
Index: pykota/trunk/man/pt_BR/pkbanner.1
===================================================================
--- pykota/trunk/man/pt_BR/pkbanner.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/pkbanner.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PKBANNER "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PKBANNER "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkbanner \- page de manuel de pkbanner 1.25alpha5_unofficial
+pkbanner \- page de manuel de pkbanner 1.25alpha16_unofficial
 .SH DESCRIPTION
-pkbanner v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+pkbanner v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 Generates banners.
Index: pykota/trunk/man/pt_BR/autopykota.1
===================================================================
--- pykota/trunk/man/pt_BR/autopykota.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/autopykota.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH AUTOPYKOTA "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH AUTOPYKOTA "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-autopykota \- page de manuel de autopykota 1.25alpha5_unofficial
+autopykota \- page de manuel de autopykota 1.25alpha16_unofficial
 .SH DESCRIPTION
-autopykota v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+autopykota v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 A tool to automate user account creation and initial balance setting.
Index: pykota/trunk/man/pt_BR/pkprinters.1
===================================================================
--- pykota/trunk/man/pt_BR/pkprinters.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/pkprinters.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PKPRINTERS "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PKPRINTERS "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkprinters \- page de manuel de pkprinters 1.25alpha5_unofficial
+pkprinters \- page de manuel de pkprinters 1.25alpha16_unofficial
 .SH DESCRIPTION
-pkprinters v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+pkprinters v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 A Printers Manager for PyKota.
Index: pykota/trunk/man/pt_BR/pknotify.1
===================================================================
--- pykota/trunk/man/pt_BR/pknotify.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/pknotify.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PKNOTIFY "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PKNOTIFY "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pknotify \- page de manuel de pknotify 1.25alpha5_unofficial
+pknotify \- page de manuel de pknotify 1.25alpha16_unofficial
 .SH DESCRIPTION
-pknotify v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+pknotify v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 Notifies or ask questions to end users who launched the PyKotIcon application.
Index: pykota/trunk/man/pt_BR/pykosd.1
===================================================================
--- pykota/trunk/man/pt_BR/pykosd.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/pykosd.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PYKOSD "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PYKOSD "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pykosd \- page de manuel de pykosd 1.25alpha5_unofficial
+pykosd \- page de manuel de pykosd 1.25alpha16_unofficial
 .SH DESCRIPTION
-pykosd v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+pykosd v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 An OSD quota monitor for PyKota.
Index: pykota/trunk/man/pt_BR/pkmail.1
===================================================================
--- pykota/trunk/man/pt_BR/pkmail.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/pkmail.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH PKMAIL "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH PKMAIL "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-pkmail \- page de manuel de pkmail 1.25alpha5_unofficial
+pkmail \- page de manuel de pkmail 1.25alpha16_unofficial
 .SH DESCRIPTION
-pkmail v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+pkmail v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 Email gateway for PyKota.
Index: pykota/trunk/man/pt_BR/dumpykota.1
===================================================================
--- pykota/trunk/man/pt_BR/dumpykota.1 (revision 2910)
+++ pykota/trunk/man/pt_BR/dumpykota.1 (revision 3065)
@@ -1,8 +1,8 @@
 .\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
-.TH DUMPYKOTA "1" "juin 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.TH DUMPYKOTA "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
 .SH NOM
-dumpykota \- page de manuel de dumpykota 1.25alpha5_unofficial
+dumpykota \- page de manuel de dumpykota 1.25alpha16_unofficial
 .SH DESCRIPTION
-dumpykota v1.25alpha5_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+dumpykota v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
 .PP
 Dumps PyKota database's content.
Index: pykota/trunk/man/pt_BR/pkrefund.1
===================================================================
--- pykota/trunk/man/pt_BR/pkrefund.1 (revision 3065)
+++ pykota/trunk/man/pt_BR/pkrefund.1 (revision 3065)
@@ -0,0 +1,96 @@
+.\" DO NOT MODIFY THIS FILE!  It was generated by help2man 1.36.
+.TH PKREFUND "1" "novembre 2006" "C@LL - Conseil Internet & Logiciels Libres" "User Commands"
+.SH NOM
+pkrefund \- page de manuel de pkrefund 1.25alpha16_unofficial
+.SH DESCRIPTION
+pkrefund v1.25alpha16_unofficial (c) 2003, 2004, 2005, 2006 Jerome Alet \- alet@librelogiciel.com
+.PP
+Refunds jobs.
+.PP
+command line usage :
+.IP
+pkrefund [options] [filterexpr]
+.PP
+options :
+.TP
+\fB\-v\fR | \fB\-\-version\fR
+Prints pkrefund's version number then exits.
+.TP
+\fB\-h\fR | \fB\-\-help\fR
+Prints this message then exits.
+.TP
+\fB\-f\fR | \fB\-\-force\fR
+Doesn't ask for confirmation before refunding jobs.
+.TP
+\fB\-r\fR | \fB\-\-reason\fR txt
+Sets textual information to explain the refunding.
+.IP
+Use the filter expressions to extract only parts of the
+datas. Allowed filters are of the form :
+.IP
+key=value
+.IP
+Allowed keys for now are :
+.TP
+username
+User's name
+.TP
+printername
+Printer's name
+.TP
+hostname
+Client's hostname
+.TP
+jobid
+Job's Id
+.TP
+billingcode
+Job's billing code
+.TP
+start
+Job's date of printing
+.TP
+end
+Job's date of printing
+.IP
+Contrary to other PyKota management tools, wildcard characters are not
+expanded, so you can't use them.
+.PP
+Examples :
+.IP
+\f(CW$ pkrefund jobid=503\fR
+.IP
+This will refund all jobs which Id is 503. BEWARE : installing CUPS
+afresh will reset the first job id at 1. So you probably want to use
+a more precise filter as explained below
+.IP
+\f(CW$ pkrefund --reason "Hardware problem" jobid=503 start=today-7\fR
+.IP
+Refunds all jobs which id is 503 but which were printed during the
+past week. The reason will be marked as being an hardware problem.
+.IP
+\f(CW$ pkrefund --force username=jerome printername=HP2100\fR
+.IP
+Refunds all jobs printed by user jerome on printer HP2100. No
+confirmation will be asked.
+.IP
+\f(CW$ pkrefund --force printername=HP2100 start=200602 end=yesterday\fR
+.IP
+Refunds all jobs printed on printer HP2100 between February 1st 2006
+and yesterday. No confirmation will be asked.
+.PP
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+.PP
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+.PP
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110\-1301, USA.
+.PP
+Please report bugs to : Jerome Alet \- alet@librelogiciel.com